#ifndef RobustMEM_
#define RobustMEM_ 

#include "Robust.h"

/** \brief  Multi Evaluation Model (MEM) */
class RobustMEM:public Robust 
{
  public: 
    RobustMEM(unsigned sampleSetSize_, bool LH_ = true):Robust(sampleSetSize_) 
    { 
      LH = LH_; 

      /* Use Monte Carlo sampling in case of Single Evaluation Model (SEM) */
      if (sampleSetSize == 1)
	LH = false;      
    }
    virtual ~RobustMEM() {}

    //! Generate sample set using Latin Hypercube sampling or Monte Carlo sampling
    void generateSampleSet();

    void robustSimulate(int* xnom, int nnom) { robustSimulate(NULL, xnom, nnom); }

  protected:  
    //! Indicates to use Latin Hypercube sampling, or Monte Carlo sampling
    bool LH;

    void robustSimulate(Individual* I, int* xnom, int numVar); 
};

#endif
