#include "SMSEMOA_2D_MIES.h"

//------------------------------------------------------------------------------
// Class SMSEMOA_2D_MIES
//-------------------------------------------------
// Protected Members

/* Sort Individuals within same front: 2D hypervolume sorting (see SMS-EMOA by Emmerich, 2005) */
void SMSEMOA_2D_MIES::frontSort(vector<int>& currFront, vector<Individual*>& Q, vector<int>& direction)
{
#ifdef DEBUG
  cout << "SMSEMOA_2D_MIES::frontSort(), 2D hypervolume sorting" << endl;
#endif

  int frontSize = currFront.size();
  map<int, double> volume;

  for (int i = 0; i < frontSize; i++)
    volume[currFront[i]] = 0;

  /* Sort front on second objective, in descending order */
  quickSort(currFront, 0, frontSize-1, &Q, selectFunction[1], NULL); 

  /* Boundary points are always kept */
  volume[currFront[0]] = DBL_MAX;
  volume[currFront[frontSize-1]] = DBL_MAX;

  /* For rest of the points, determine hypervolume contribution */
  for (int i = 1; i < frontSize-1; i++) 
    volume[currFront[i]] += (Q[currFront[i+1]]->F[selectFunction[0]] - Q[currFront[i]]->F[selectFunction[0]]) 
	                      * (Q[currFront[i-1]]->F[selectFunction[1]] - Q[currFront[i]]->F[selectFunction[1]]);

  /* Sort front index currFront on hypervolume, in descending order */
  quickSort(currFront, 0, frontSize-1, NULL, 0, &volume);
}


