#include "SMSEMOA_Steady3D_MIES.h"

//------------------------------------------------------------------------------
// Class SMSEMOA_Steady3D_MIES
//-------------------------------------------------
// Protected Members

/* Normalize Individuals in Q and prepare dataHv */
void SMSEMOA_Steady3D_MIES::prepComparisonScore(vector<Individual*>& Q)
{
  int size = Q.size();
  static vector<int> indices; 
  if (indices.size() == 0)
  {
    for (int i = 0; i < size; i++)
      indices.push_back(i);
  }

  /* Normalize to [0,1]->min using Ideal and Nadir points of Individuals in vector Q */
  normalize(indices, size, Q, direction);

  /* Prepare dataset to be fed to hv() using normalized F values in normF, excluding the offspring Individuals */
  for (unsigned i = 0; i < numIndividuals-1; i++)
  { 
    for (int j = 0; j < 3; j++) 
      dataHv[3*i + j] = normF[i][selectFunction[j]];
  }
}

/* Calculates 3D HV contr. approximations for pre-selecting "best" offspring Individual */
double SMSEMOA_Steady3D_MIES::calcComparisonScore(unsigned offspringIndex)
{
#ifdef DEBUG
  cout << "SMSEMOA_Steady3D_MIES::comparisonScore()" << endl;
#endif

  /* Add offspring Individual offspringIndex to dataHv */
  for (int j = 0; j < 3; j++) 
    dataHv[3*(numIndividuals-1) + j] = normF[(numIndividuals-1) + offspringIndex][selectFunction[j]];

  /* Calculate total hypervolume of dataHv; 
   * dataHv consists of population P and one offspring Individual, 
   * and optionally excludes the offspring Individual's parent */
  double score = fpli_hv(dataHv, 3, numIndividuals, reference);

  return score;
}

