#ifndef TESTMIES
#define TESTMIES

#include <map>

#ifdef MSCTHES    
#include "../mscthes/MOTestFunctions.h"
#endif

#ifdef APRIORI
#include "APriori_MIES.h"
class TestFunctions_MIES:public APriori_MIES
# ifdef MSCTHES    
, public MOTestFunctions
# endif
{
  public:
    TestFunctions_MIES(unsigned n_r_, unsigned n_z_, unsigned n_d_, unsigned n_sigma_r_, unsigned n_sigma_z_, unsigned n_prob_, unsigned n_f_, 
		                    unsigned mu_, unsigned rho_, unsigned kappa_, unsigned lambda_,  
		                      vector<double>& lBound_r_, vector<double>& uBound_r_, vector<int>& lBound_z_, vector<int>& uBound_z_, 
		                        vector<int>& lBound_d_, vector<int>& uBound_d_, double prob_min_, double prob_max_,
			                        bool disRec_r_, bool disRec_z_, bool disRec_sigma_r_, bool disRec_sigma_z_, bool disRec_prob_,
			                          bool selfAdaptation_, vector<int>& direction_, 
			                            unsigned evaluations_, vector<double>& optimalF_, 
				                            double initialSigma_r_, double initialSigma_z_, double initialProb_,
				                              ifstream* initialPopFile_, int randomSeed_, bool feedback_, 
				                                unsigned timeOutValue_,
				                                  unsigned selectDimension_, vector<unsigned>& selectFunction_,
 					                                  string MOproblem_, bool excludeParent_) 
      :APriori_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                 mu_, rho_, kappa_, lambda_,  
		                   lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                     lBound_d_, uBound_d_, prob_min_, prob_max_,
			                     disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                       selfAdaptation_, direction_, 
			                         evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
			                           initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                             selectDimension_, selectFunction_)
#endif
#ifdef NSGAII
# ifdef STEADY
#include "NSGAII_Steady_MIES.h"
class TestFunctions_MIES:public NSGAII_Steady_MIES
# else
#include "NSGAII_MIES.h"
class TestFunctions_MIES:public NSGAII_MIES
# endif
# ifdef MSCTHES    
, public MOTestFunctions
# endif
{
  public:
    TestFunctions_MIES(unsigned n_r_, unsigned n_z_, unsigned n_d_, unsigned n_sigma_r_, unsigned n_sigma_z_, unsigned n_prob_, unsigned n_f_, 
		                    unsigned mu_, unsigned rho_, unsigned kappa_, unsigned lambda_,  
		                      vector<double>& lBound_r_, vector<double>& uBound_r_, vector<int>& lBound_z_, vector<int>& uBound_z_, 
		                        vector<int>& lBound_d_, vector<int>& uBound_d_, double prob_min_, double prob_max_,
			                        bool disRec_r_, bool disRec_z_, bool disRec_sigma_r_, bool disRec_sigma_z_, bool disRec_prob_,
			                          bool selfAdaptation_, vector<int>& direction_, 
			                            unsigned evaluations_, vector<double>& optimalF_, 
                                    double initialSigma_r_, double initialSigma_z_, double initialProb_,
				                              ifstream* initialPopFile_, int randomSeed_, bool feedback_, 
				                                unsigned timeOutValue_,
				                                  unsigned selectDimension_, vector<unsigned>& selectFunction_,
 					                                  string MOproblem_, bool excludeParent_) 
      :
# ifdef STEADY
       NSGAII_Steady_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                       mu_, rho_, kappa_, lambda_,  
		                         lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                           lBound_d_, uBound_d_, prob_min_, prob_max_,
			                           disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                             selfAdaptation_, direction_, 
			                               evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
			                                 initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                                   selectDimension_, selectFunction_,
					                                 excludeParent_),      
# endif
       NSGAII_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                mu_, rho_, kappa_, lambda_,  
		                  lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                    lBound_d_, uBound_d_, prob_min_, prob_max_,
			                    disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                      selfAdaptation_, direction_, 
			                        evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
			                          initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                            selectDimension_, selectFunction_) 
#endif
#ifdef SMSEMOA2D
# ifdef STEADY
#include "SMSEMOA_Steady2D_MIES.h"
class TestFunctions_MIES:public SMSEMOA_Steady2D_MIES
# else
#include "SMSEMOA_2D_MIES.h"
class TestFunctions_MIES:public SMSEMOA_2D_MIES
# endif
# ifdef MSCTHES    
, public MOTestFunctions
# endif
{
  public:
    TestFunctions_MIES(unsigned n_r_, unsigned n_z_, unsigned n_d_, unsigned n_sigma_r_, unsigned n_sigma_z_, unsigned n_prob_, unsigned n_f_, 
		                    unsigned mu_, unsigned rho_, unsigned kappa_, unsigned lambda_,  
		                      vector<double>& lBound_r_, vector<double>& uBound_r_, vector<int>& lBound_z_, vector<int>& uBound_z_, 
		                        vector<int>& lBound_d_, vector<int>& uBound_d_, double prob_min_, double prob_max_,
			                        bool disRec_r_, bool disRec_z_, bool disRec_sigma_r_, bool disRec_sigma_z_, bool disRec_prob_,
			                          bool selfAdaptation_, vector<int>& direction_, 
			                            unsigned evaluations_, vector<double>& optimalF_, 
				                            double initialSigma_r_, double initialSigma_z_, double initialProb_,
				                              ifstream* initialPopFile_, int randomSeed_, bool feedback_, 
				                                unsigned timeOutValue_,
				                                  unsigned selectDimension_, vector<unsigned>& selectFunction_,
					                                  string MOproblem_, bool excludeParent_) 
# ifdef STEADY
      :SMSEMOA_Steady2D_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                          mu_, rho_, kappa_, lambda_,  
		                            lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                              lBound_d_, uBound_d_, prob_min_, prob_max_,
			                              disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                                selfAdaptation_, direction_, 
			                                  evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
				                                  initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                                      selectDimension_, selectFunction_,
				                                      excludeParent_),
# else
      :SMSEMOA_2D_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                    mu_, rho_, kappa_, lambda_,  
		                      lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                        lBound_d_, uBound_d_, prob_min_, prob_max_,
			                        disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                          selfAdaptation_, direction_, 
			                            evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
				                            initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                                selectDimension_, selectFunction_),
# endif      
       NSGAII_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                mu_, rho_, kappa_, lambda_,  
		                  lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                    lBound_d_, uBound_d_, prob_min_, prob_max_,
		                      disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
		                        selfAdaptation_, direction_, 
		                          evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
		                            initialPopFile_, randomSeed_, feedback_, timeOutValue_,
		                              selectDimension_, selectFunction_)
#endif
#ifdef SMSEMOA3D
# ifdef STEADY
#include "SMSEMOA_Steady3D_MIES.h"
class TestFunctions_MIES:public SMSEMOA_Steady3D_MIES
# else
#include "SMSEMOA_3D_MIES.h"
class TestFunctions_MIES:public SMSEMOA_3D_MIES
# endif
# ifdef MSCTHES    
, public MOTestFunctions
# endif
{
  public:
    TestFunctions_MIES(unsigned n_r_, unsigned n_z_, unsigned n_d_, unsigned n_sigma_r_, unsigned n_sigma_z_, unsigned n_prob_, unsigned n_f_, 
		                    unsigned mu_, unsigned rho_, unsigned kappa_, unsigned lambda_,  
		                      vector<double>& lBound_r_, vector<double>& uBound_r_, vector<int>& lBound_z_, vector<int>& uBound_z_, 
		                        vector<int> lBound_d_, vector<int> uBound_d_, double prob_min_, double prob_max_,
			                        bool disRec_r_, bool disRec_z_, bool disRec_sigma_r_, bool disRec_sigma_z_, bool disRec_prob_,
			                          bool selfAdaptation_, vector<int>& direction_, 
			                            unsigned evaluations_, vector<double>& optimalF_, 
                                    double initialSigma_r_, double initialSigma_z_, double initialProb_,
				                              ifstream* initialPopFile_, int randomSeed_, bool feedback_, 
				                                unsigned timeOutValue_,
				                                  unsigned selectDimension_, vector<unsigned>& selectFunction_,
 					                                  string MOproblem_, bool excludeParent_) 
# ifdef STEADY
      :SMSEMOA_Steady3D_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                          mu_, rho_, kappa_, lambda_,  
		                            lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                              lBound_d_, uBound_d_, prob_min_, prob_max_,
			                              disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                                selfAdaptation_, direction_, 
			                                  evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
				                                  initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                                      selectDimension_, selectFunction_,
				                                      excludeParent_),
       NSGAII_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                mu_, rho_, kappa_, lambda_,  
		                  lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                    lBound_d_, uBound_d_, prob_min_, prob_max_,
		                      disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
		                        selfAdaptation_, direction_, 
		                          evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
		                            initialPopFile_, randomSeed_, feedback_, timeOutValue_,
		                              selectDimension_, selectFunction_)
# else
      :SMSEMOA_3D_MIES(n_r_, n_z_, n_d_, n_sigma_r_, n_sigma_z_, n_prob_, n_f_, 
		                    mu_, rho_, kappa_, lambda_,  
		                      lBound_r_, uBound_r_, lBound_z_, uBound_z_, 
		                        lBound_d_, uBound_d_, prob_min_, prob_max_,
			                        disRec_r_, disRec_z_, disRec_sigma_r_, disRec_sigma_z_, disRec_prob_,
			                          selfAdaptation_, direction_, 
			                            evaluations_, optimalF_, initialSigma_r_, initialSigma_z_, initialProb_,
				                            initialPopFile_, randomSeed_, feedback_, timeOutValue_,
			                                selectDimension_, selectFunction_)
# endif                           
#endif
#ifdef MSCTHES     
                                      { MOproblem = MOproblem_; }
#else
                                      { MOproblem = " "; }
#endif

    ~TestFunctions_MIES() {}

  protected:
    /** \brief  Determines whether a member of MOTestFunction should be evaluated instead of the suite of f test problems listed below */
    string MOproblem; 

    /** \brief  Run simulator using the object variables contained in Individual I */
    void simulate(Individual* I); 
    /** \brief  f1: modified step function             (see Mixed-Integer Evolution Strategy by Emmerich, 2000) */
    double f1(Individual* I);      
    /** \brief  f2: weighted sphere function           (see Mixed-Integer Evolution Strategy by Emmerich, 2000) */
    double f2(Individual* I);      
    /** \brief  f3: general quadratic fitness function (see Mixed-Integer Evolution Strategy by Emmerich, 2000) */
    double f3(Individual* I);      
    /** \brief  f_sphere: generalized sphere function  (see Mixed-Integer Evolution Strategies by Li, 2006) */
    double f_sphere(Individual* I, unsigned n_r, unsigned n_z, unsigned n_d);
    /** \brief  f_barrier: multimodal barrier problem  (see Mixed-Integer Evolution Strategies by Li, 2006) */
    double f_barrier(Individual* I, int C);                                    

    /** \brief  Write current population P to file */
    void writePop(time_t id);

    /** \brief  Log time that was needed to complete generation */
    void writeLog(time_t elapsed, time_t id); 
};

#endif
