/* Routines to decode the population */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Function to decode a population to find out the binary variable values based on its bit pattern */
void decode_pop (population *pop)
{
    int i;
    if (nbin!=0)
    {
        for (i=0; i<popsize; i++)
        {
            decode_ind (&(pop->ind[i]));
        }
    }
    return;
}

/* Function to decode an individual to find out the binary variable values based on its bit pattern */
void decode_ind (individual *ind)
{
    int j, k;
    int index_value;
    if (nbin!=0)
    {
        for (j=0; j<nbin; j++)
        {
            index_value=0;
            for (k=0; k<nbits[j]; k++)
            {
                if (ind->gene[j][k]==1)
                {
                    index_value += pow(2,nbits[j]-1-k);
                }
            }
            ind->xbin[j] = min_binvar[j] + (double)index_value*(max_binvar[j] - min_binvar[j])/(double)(pow(2,nbits[j])-1);
        }
    }
    return;
}

/* Function to decode an individual to find out the binary variable values based on its bit pattern, inserted: ereehuis */
void encode_ind (individual *ind)
{
    int j, k;
    int index_value;
    if (nbin!=0)
    {
        for (j=0; j<nbin; j++)
        {
            index_value = ((ind->xbin[j] - min_binvar[j]) * (double)(pow(2,nbits[j])-1)) / (double)(max_binvar[j] - min_binvar[j]);
            for (k=0; k<nbits[j]; k++)
            {
		if (index_value % 2 == 1)
		{
		    ind->gene[j][nbits[j]-1-k] = 1;
		}
		index_value /= 2;
            }
        }
    }
    return;
}
