#!/gnuplot

set xrange [0.5e6:1.0e7]
set yrange [0:1.1]
set zrange [17:25]

set xtics ("2.5M" 2.5e6, "5M" 5e6, "7.5M" 7.5e6, "10M" 10e6)
set ytics ("0" 0, "  0.5" 0.5, "1" 1)
set ztics ("17" 17, "24" 24)

set term postscript landscape color enhanced dashed linewidth 1 "Arial" 20
set style line 1 pt 7 ps 0.04 lc rgb "red" 
set style line 2 pt 7 ps 0.04 lc rgb "blue" 
set style line 3 pt 7 ps 0.04 lc rgb "black" 

unset border
set xtics nomirror
set ytics nomirror
set xlabel "\n{/Arial-Italic-Bold F_1}\n({/Arial-Bold Investment Cost})\n->\n{/Arial-Italic min}"
set ylabel "{/Arial-Italic-Bold F_2}\n({/Arial-Bold weighted}\n{/Arial-Bold Demand}\n{/Arial-Bold Supply Ratio})\n->\n{/Arial-Italic MAX}"
set zlabel "{/Arial-Italic-Bold F_3}         \n({/Arial-Bold System}         \n{/Arial-Bold Entropy})         \n->         \n{/Arial-Italic MAX}         "

set view 15, 210

set size 1.08,1.08
set origin 0.0,0.0

set output "plot/best.ps"
splot "plot/best.txt" notitle w p ls 1

set output "plot/median.ps"
splot "plot/median.txt" notitle w p ls 2

set output "plot/worst.ps"
splot "plot/worst.txt" notitle w p ls 3



