#!/bin/csh -f

if ($# < 4) then
  echo "Usage: $0 N|I WDNproblem *_stepsizes.txt RunID"
  exit
endif

set plotDir     = "plot"
set ghostScript = "gs"
set gnuplot     = "gnuplot"

if ($2 == "T") then
  set n = 8
else if ($2 == "H") then
  set n = 34
else if ($2 == "N") then
  set n = 21
endif  

$gnuplot << EOF
set term postscript landscape color enhanced dashed linewidth 1 "Arial" 20

set output "$plotDir/stepsizes.ps"

type = "$1"

set xrange [*:*]
if (type eq "N") set yrange [0:0.5]; else set yrange [*:*];

set xtics auto
set ytics auto

set xlabel "{/Arial-Bold generation}"

set size 1.13,1.16
set origin -0.1,-0.1

set lmargin 6
set rmargin 3

if (type eq "N") plot '$3' u 1:2 w l lt 1 notitle, '$3' u 1:3 w l lt 3 lc rgb "black" notitle, '$3' u 1:4 w l lt 3 lc rgb "black" notitle, x**0 * 1/$n title "1/n"; else plot '$3' u 1:2 w l lt 1 notitle, '$3' u 1:3 w l lt 3 lc rgb "black" notitle, '$3' u 1:4 w l lt 3 lc rgb "black" notitle;
EOF

"$ghostScript" -dSAFER -dBATCH -dNOPAUSE -sDEVICE=pdfwrite -sOutputFile=$plotDir/RunID_$4_stepsizes.pdf $plotDir/stepsizes.ps

rm $plotDir/stepsizes.ps
